#include <iostream>
using std::cout;
using std::endl;

#include "linalg.h"

double A[6*6] = {  1,  2,  3,  4,  5,  6,
                   5,  1,  2,  3,  4,  5,
                  -1,  0,  1, -7,  3,  4,
                  -2, 12,  0,  1,  2,  3,
                  -3, -3, -1,  0, 13,  2,
                  -4, -3, -5, -5,  0,  1  };

double B[6*6] =  { 1,  0,  3,  0,  5,  1,
                   0,  1,  1,  1,  4,  0,
                  -1,  0,  1, -7,  1,  4,
                  -2,  1,  0,  1,  0,  3,
                  -0, -3, -1,  0,  1,  2,
			      -1, -1, -5, -1,  0,  0 };
				
int main()
{
	cout << "A =" << endl;
	format(cout,A,6,6);
	const double detA = determinant(A,6);
	cout << "det(A) = " <<  detA << endl << endl;

	cout << "B =" << endl;
	format(cout,B,6,6);
	const double detB = determinant(B,6);
	cout << "det(B) = " << detB << endl << endl;
	
	double AB[6*6];
	multiply(AB,A,B,6,6,6);
	cout << "AB =" << endl;
	format(cout,AB,6,6);
	const double detAB = determinant(AB,6);
	cout.precision(12);
	cout << "det(AB) = " << detAB << endl;
	cout << "det(A)*det(B) = " << detA*detB << endl << endl;

	multiply_Rtranspose(AB,A,B,6,6,6);
	cout << "ABt =" << endl;
	format(cout,AB,6,6);
	const double detABt = determinant(AB,6);
	cout << "det(ABt) = " << detABt << endl;
	cout << "det(A)*det(B) = " << detA*detB << endl;
	
	return 0;
}