#include <iostream>
using std::cout;
using std::endl;

#include "linalg.h"

const double A[2*2] = {  4, -3,
					    -2,  1  };

const double B[3*3] = {  3, -4,  1,
                         5,  3, -7,
						-9,  2,  6  };

const double C[3*4] = {  2, -5,  6,  1,
						-9, -7,  1,  4,
						 8,  2,  9,  3  };
					  
int main()
{
	cout << "A =" << endl;
	format(cout,A,2,2);
	cout << "det(A) = " << determinant2(A) << endl << endl;
	
	cout << "B =" << endl;
	format(cout,B,3,3);
	cout << "det(B) = " << determinant3(B) << endl << endl;
	
	cout << "B*B = " << endl;
	double B2[3*3];
	multiply(B2,B,B,3,3,3);
	format(cout,B2,3,3);
	cout << "det(B*B) = " << determinant3(B2) << endl << endl;
	
	cout << "B*Bt = " << endl;
	multiply_Rtranspose(B2,B,B,3,3,3);
	format(cout,B2,3,3);
	cout << "det(B*Bt) = " << determinant3(B2) << endl << endl;
	
	cout << "C =" << endl;
	format(cout,C,3,4);
	
	cout << endl << "C*Ct =" << endl;
	double CCt[3*3];
	multiply_Rtranspose(CCt,C,C,3,4,3);
	format(cout,CCt,3,3);	
	cout << "det(C*Ct) = " << determinant3(CCt) << endl;

	return 0;
}